package com.supermap.mapping.imobile;

import com.example.eagleeyesctrl.R;
import com.supermap.data.Environment;
import com.supermap.data.Point2D;
import com.supermap.data.Rectangle2D;
import com.supermap.data.Workspace;
import com.supermap.data.WorkspaceConnectionInfo;
import com.supermap.data.WorkspaceType;
import com.supermap.mapping.MapControl;
import com.supermap.mapping.MapParameterChangedListener;

import android.os.Bundle;
import android.app.Activity;
import android.util.Log;

public class EEMainActivity extends Activity {

	Workspace workspace;
	MapControl mapControl;
	EagleEyesMapCtrl eagleEyesMapCtrl;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		try {

			// һЩϵͳҪõ·
			Environment.setLicensePath(getString(R.string.license_path));
			Environment.setTemporaryPath(getString(R.string.temp_path));
			Environment.setWebCacheDirectory(getString(R.string.cache_path));
			Environment.initialization(this);

			setContentView(R.layout.ee_main);

			openData();

		} catch (Exception e) {
			// TODO: handle exception
			Log.e("ERROR", "ERROR IN CODE: " + e.toString());

			e.printStackTrace();
		}
	}
	
	@Override
	protected void onDestroy(){
		mapControl.removeMapParamChangedListener(mapParameterChangedListener);
		mapControl.dispose();
		eagleEyesMapCtrl.dispose();
	}

	private void openData() {
		// 򿪹ռ
		workspace = new Workspace();
		WorkspaceConnectionInfo info = new WorkspaceConnectionInfo();
		info.setServer(getString(R.string.data_path));
		info.setType(WorkspaceType.SMWU);
		workspace.open(info);

		String mapName = workspace.getMaps().get(0);
		mapControl = (MapControl) findViewById(R.id.mapCtrl);
		mapControl.getMap().setWorkspace(workspace);

		mapControl.getMap().open(mapName);
		mapControl.getMap().refresh();
		mapControl.setMapParamChangedListener(mapParameterChangedListener);

		eagleEyesMapCtrl = (EagleEyesMapCtrl) findViewById(R.id.eagleEyes);
		eagleEyesMapCtrl.getMap().setWorkspace(workspace);
		eagleEyesMapCtrl.setMainMap(mapName);
		eagleEyesMapCtrl.displayRect(mapControl.getMap().getViewBounds());
		
		eagleEyesMapCtrl.addEagleEyeListener(new EagleEyeListener() {
			
			@Override
			public void eagleEyeChanged(EagleEyeEvent arg0) {
				// TODO Auto-generated method stub
				Point2D mapCenter = arg0.getMapCenter();
				mapControl.getMap().setCenter(mapCenter);
				mapControl.getMap().refresh();
			}
		});
	}

	private final MapParameterChangedListener mapParameterChangedListener = new MapParameterChangedListener() {

		@Override
		public void scaleChanged(double arg0) {
			updateEagleEye();
		}

		@Override
		public void boundsChanged(Point2D arg0) {
			updateEagleEye();
		}
	};

	private void updateEagleEye() {
		Rectangle2D rc = mapControl.getMap().getViewBounds();
		eagleEyesMapCtrl.displayRect(rc);
	}
}
