package com.supermap.mapping.imobile;

import java.util.Vector;

import android.content.Context;
import android.util.AttributeSet;
import android.view.MotionEvent;

import com.supermap.data.Color;
import com.supermap.data.GeoLine;
import com.supermap.data.GeoStyle;
import com.supermap.data.Point;
import com.supermap.data.Point2D;
import com.supermap.data.Point2Ds;
import com.supermap.data.Rectangle2D;
import com.supermap.data.Workspace;
import com.supermap.mapping.MapControl;
import com.supermap.mapping.TrackingLayer;

public class EagleEyesMapCtrl extends MapControl{

	private Rectangle2D rcMainMap;
	
	private Vector eagleEyeListeners;

	private Point2D pntCenter;
	
	public EagleEyesMapCtrl(Context context) {
		super(context, new Workspace());
	}

	public EagleEyesMapCtrl(Context context, AttributeSet attrs) {
		super(context, attrs);
	}

	//ӥ۹ͼⲿֻһ
	public void setMainMap(String mapName) {
		this.getMap().open(mapName);
		this.getMap().viewEntire();
	}
	
	public boolean onTouchEvent (MotionEvent event) 
	{
		Point pnt = new Point((int)(event.getX()),(int)(event.getY()));
		pntCenter = getMap().pixelToMap(pnt);
		if (!rcMainMap.contains(pntCenter)) {			
			EagleEyeEvent eagleEyeEvent = new EagleEyeEvent(this, pntCenter);
			fireEagleEyeChanged(eagleEyeEvent);
		}
		return true;
	}


	public synchronized void addEagleEyeListener(
			EagleEyeListener eagleEyeListener) {
		if (this.eagleEyeListeners == null)
			this.eagleEyeListeners = new Vector();
		if (!this.eagleEyeListeners.contains(eagleEyeListener))
			this.eagleEyeListeners.add(eagleEyeListener);
	}
	
	public synchronized void removeEagleEyeListener(
			EagleEyeListener eagleEyeListener) {
		if ((this.eagleEyeListeners != null)
				&& (this.eagleEyeListeners.contains(eagleEyeListener)))
			this.eagleEyeListeners.remove(eagleEyeListener);
	}
	
	protected void fireEagleEyeChanged(EagleEyeEvent eagleEyeEvent) {
		if (this.eagleEyeListeners != null) {
			Vector localVector = this.eagleEyeListeners;
			int i = localVector.size();
			for (int j = 0; j < i; j++)
				((EagleEyeListener) localVector.elementAt(j))
						.eagleEyeChanged(eagleEyeEvent);
		}
	}

	public void displayRect(Rectangle2D rectangleDisplay) {
		rcMainMap = rectangleDisplay;

		Point2D point2D1 = this.getMap().pixelToMap(new Point(2, 2));
		int width = this.getWidth() - 2;
		int height = this.getHeight() - 2;
		Point2D point2D2 = this.getMap().pixelToMap(
				new Point(width, height));

		// ԺĿ
		double left = rectangleDisplay.getLeft() > point2D1.getX() ? rectangleDisplay
				.getLeft() : point2D1.getX();
		double top = rectangleDisplay.getTop() > point2D1.getY() ? point2D1
				.getY() : rectangleDisplay.getTop();
		double right = rectangleDisplay.getRight() > point2D2.getX() ? point2D2
				.getX() : rectangleDisplay.getRight();
		double bottom = rectangleDisplay.getBottom() > point2D2.getY() ? rectangleDisplay
				.getBottom() : point2D2.getY();

		// 
		GeoLine geoLine = new GeoLine();
		Point2Ds ponit2Ds = new Point2Ds();
		ponit2Ds.add(new Point2D(left, top));
		ponit2Ds.add(new Point2D(right, top));
		ponit2Ds.add(new Point2D(right, bottom));
		ponit2Ds.add(new Point2D(left, bottom));
		ponit2Ds.add(new Point2D(left, top));
		geoLine.addPart(ponit2Ds);
		GeoStyle geoStyle = new GeoStyle();
		geoStyle.setLineColor(new Color(255, 0, 0));
		geoLine.setStyle(geoStyle);

		// Ӻ
		TrackingLayer trackingLayer = this.getMap()
				.getTrackingLayer();
		trackingLayer.clear();
		trackingLayer.add(geoLine, "");		
		this.getMap().refresh();
	}
}
